package net.plil.clubinfo.etunicorn.app.consomation;

import android.content.Context;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import net.plil.clubinfo.etunicorn.R;
import net.plil.clubinfo.etunicorn.app.FragmentNFC;
import net.plil.clubinfo.etunicorn.data.Consomation;

import java.util.ArrayList;
import java.util.List;

/**
 * A fragment representing a list of Items.
 * <p/>
 * Activities containing this fragment MUST implement the {@link OnListFragmentInteractionListener}
 * interface.
 */
public class FragmentConsomation extends FragmentNFC {

    private OnListFragmentInteractionListener mListener;

    /**
     * Mandatory empty constructor for the fragment manager to instantiate the
     * fragment (e.g. upon screen orientation changes).
     */
    public FragmentConsomation() {
    }

    public static FragmentConsomation newInstance() {
        return new FragmentConsomation();
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_consomation_item_list, container, false);
        RecyclerView recyclerView = (RecyclerView) view.findViewById(R.id.consomation_list);
        // Set the adapter
        Context context = recyclerView.getContext();

        recyclerView.setLayoutManager(new LinearLayoutManager(context));

        List<Consomation> consomationList = new ArrayList<>();
        Consomation c1 = new Consomation();
        c1.setIdConsomation(1);
        c1.setNomConsomation("Hello");
        c1.setPrix(12.5);
        consomationList.add(c1);
        for (int i = 0; i< 100; ++i){
            c1 = new Consomation();
            c1.setIdConsomation(i);
            c1.setNomConsomation("World");
            c1.setPrix(42.407);
            consomationList.add(c1);
        }
        recyclerView.setAdapter(new ConsomationRecyclerViewAdapter(consomationList,  mListener));

        FloatingActionButton fAB = (FloatingActionButton) view.findViewById(R.id.consomation_add);
        fAB.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CreateConsomation newFragment = new CreateConsomation();
                newFragment.show(getFragmentManager(), "CreateConsomation");
            }
        });

        return view;
    }


    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        if (context instanceof OnListFragmentInteractionListener) {
            mListener = (OnListFragmentInteractionListener) context;
        } else {
            throw new RuntimeException(context.toString()
                    + " must implement OnListFragmentInteractionListener");
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    @Override
    public void processNFC() {

    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p/>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnListFragmentInteractionListener {
        void onListFragmentInteraction(Consomation item);
    }
}
